Attribute VB_Name = "MMatrix"
'VIP Software
':        25.12.1999
':           
':           ,   .
'                 ,  ,     
': 18.05.2005
'                 
'               ,  
Option Explicit
'  
':  Matrix -  ,   ( ,   !!!)
':  
Public Function Determinant(Matrix() As Double) As Double
Dim D As Double

    On Error GoTo ErrDeterminant
    '    
    If UBound(Matrix, 1) <> UBound(Matrix, 2) Then Exit Function
    Dim m_Size As Long: m_Size = UBound(Matrix)
    '     
    Select Case m_Size
    Case 1
        '  ?  
        Exit Function
    Case 2
        '    
        D = Matrix(1, 1) * Matrix(2, 2) - Matrix(2, 1) * Matrix(1, 2)
    Case 3
        '    
        D = Matrix(1, 1) * Matrix(2, 2) * Matrix(3, 3) + Matrix(1, 2) * Matrix(2, 3) * Matrix(3, 1) + _
            Matrix(1, 3) * Matrix(2, 1) * Matrix(3, 2) - Matrix(1, 3) * Matrix(2, 2) * Matrix(3, 1) - _
            Matrix(1, 1) * Matrix(2, 3) * Matrix(3, 2) - Matrix(1, 2) * Matrix(2, 1) * Matrix(3, 3)
    Case Else
        '     
        ' () 
        Dim M() As Double
        
        M = ToTrapeze(Matrix)
        Dim i As Long
        '     
        D = 1#
        For i = 1 To m_Size
            D = D * M(i, i)
        Next i
    End Select
    Determinant = D
ErrDeterminant:
End Function
'    
'    
':  Matrix -  ,   ( ,   !!!)
'       iRange - ,  ,  ,   
': ,  ,    
Public Function ToTrapeze(Matrix() As Double, Optional iRange As Long) As Double()
Dim M() As Double

    On Error GoTo ErrToTrapeze
    M = Matrix                                          '  ,     
    Dim i As Long, j As Long, k As Long                 '
    Dim Sign As Boolean                                 '    
    Dim q As Double                                     '
    Dim m_Rows As Double: m_Rows = UBound(M)            ' 
    Dim m_Columns As Double: m_Columns = UBound(M, 2)   ' 
    
    For k = 1 To Min(m_Rows - 1, m_Columns)
        If M(k, k) = 0# Then
            '     
            i = k
            j = k + 1
            '  ,    
            Do While M(i, j) = 0#
                j = j + 1
                If j > m_Columns Then
                    i = i + 1
                    If i > m_Rows Then
                        '  
                        iRange = k - 1
                        GoTo ErrToTrapeze
                    Else
                        j = k
                    End If
                End If
            Loop
            '  / 
            If i = k Then
                ' 
                M = SwapCols(M, k, j)
                Sign = Not Sign
            ElseIf j = k Then
                ' 
                M = SwapRows(M, i, k)
                Sign = Not Sign
            Else
                '    
                M = SwapCols(M, k, j)
                M = SwapRows(M, k, i)
            End If
        End If
        '   
        For i = k + 1 To m_Rows
            q = -M(i, k) / M(k, k)
            M(i, k) = 0
            For j = k + 1 To m_Columns
                M(i, j) = M(i, j) + q * M(k, j)
            Next j
        Next i
    Next k
    If m_Columns < m_Rows Then
        iRange = m_Columns
    ElseIf M(m_Rows, m_Rows) = 0 Then
        iRange = m_Rows - 1
    Else
        iRange = m_Rows
    End If
ErrToTrapeze:
    If Sign Then
        '   
        ToTrapeze = MultiplyByScalar(M, -1#)
    Else
        ToTrapeze = M
    End If
End Function
'      
':  Matrix -  ,   ( ,   !!!)
'       FirstCol, SecondCol -   
':    
Public Function SwapCols(Matrix() As Double, ByVal FirstCol As Long, ByVal SecondCol As Long) As Double()
    Dim M() As Double

    On Error GoTo ErrSwapCols
    
    Dim m_Rows As Double: m_Rows = UBound(Matrix)
    Dim m_Columns As Double: m_Columns = UBound(Matrix, 2)
    
    M = Matrix
    '   
    If FirstCol > 0 And FirstCol <= m_Columns Then
        If SecondCol > 1 And SecondCol <= m_Columns Then
            Dim tmp As Double
            Dim i As Long
            For i = 1 To m_Rows
                tmp = M(i, FirstCol)
                M(i, FirstCol) = M(i, SecondCol)
                M(i, SecondCol) = tmp
            Next i
        End If
    End If
ErrSwapCols:
    SwapCols = M
End Function
'      
':  Matrix -  ,   ( ,   !!!)
'       FirstRow, SecondRow -   
':    
Public Function SwapRows(Matrix() As Double, ByVal FirstRow As Long, ByVal SecondRow) As Double()
Dim M() As Double
Dim m_Rows As Double: m_Rows = UBound(Matrix)
Dim m_Columns As Double: m_Columns = UBound(Matrix, 2)

    On Error GoTo ErrSwapRows
    M = Matrix
    '   
    If FirstRow > 0 And FirstRow <= m_Rows Then
        If SecondRow > 0 And SecondRow <= m_Rows Then
            Dim tmp As Double
            Dim i As Long
            For i = 1 To m_Columns
                tmp = M(FirstRow, i)
                M(FirstRow, i) = M(SecondRow, i)
                M(SecondRow, i) = tmp
            Next i
        End If
    End If
ErrSwapRows:
    SwapRows = M
End Function
' ,  
':  Matrix -  ,   ( ,   !!!)
': ,  
Public Function DumpMatrix(Matrix() As Double) As String
Dim sDump As String
Dim m_Rows As Double: m_Rows = UBound(Matrix)
Dim m_Columns As Double: m_Columns = UBound(Matrix, 2)

    '    
    On Error Resume Next
    Dim i As Long, j As Long
    For i = 1 To m_Rows
        For j = 1 To m_Columns
            sDump = sDump & Format(Matrix(i, j), "0.##") & vbTab
        Next j
        sDump = Left$(sDump, Len(sDump) - 1)    '  vbTab
        sDump = sDump & vbCrLf
    Next i
    DumpMatrix = Left$(sDump, Len(sDump) - 2)   '  vbCrLf
End Function
' ,  
':  Vector - ,   ( ,   !!!)
': ,  
Public Function DumpVector(Vector() As Double) As String
Dim sDump As String
Dim m_Count As Double: m_Count = UBound(Vector)

    '    
    On Error Resume Next
    Dim i As Long
    For i = 1 To m_Count
        sDump = sDump & Format(Vector(i), "0.##") & vbTab
    Next i
    DumpVector = Left$(sDump, Len(sDump) - 1)     '  vbTab
End Function
'    Number    
':  Matrix -  ,   ( ,   !!!)
'       Number - ,    ,    1.0
': - 
Public Function MultiplyByScalar(Matrix() As Double, Optional ByVal Number As Double = 1#) As Double()
Dim Result() As Double
Dim m_Rows As Double: m_Rows = UBound(Matrix)
Dim m_Columns As Double: m_Columns = UBound(Matrix, 2)

    On Error GoTo ErrMultiplyByScalar
    
    If Number = 1# Then
        MultiplyByScalar = Matrix   '  
        Exit Function
    End If
    ReDim Result(m_Rows, m_Columns)
    If Number = 0# Then
        MultiplyByScalar = Result   ' ,   
        Exit Function
    End If
    Dim i As Long, j As Long
    For i = 1 To m_Rows
        For j = 1 To m_Columns
            Result(i, j) = Matrix(i, j) * Number
        Next j
    Next i
    MultiplyByScalar = Result
ErrMultiplyByScalar:
End Function
'    AX=B  
':  A -  ,    ( ,   !!!)
'       B - ,     ( ,   !!!)
'       X - ,     ( ,   !!!)
': True,   , False,   
Public Function LineSystemGauss(A() As Double, B() As Double, _
                        X() As Double) As Boolean

    On Error GoTo ErrLineSystemGauss
    '   
    If UBound(A, 1) <> UBound(A, 2) Then Exit Function


    Dim tmp As Double   ' 

    ' 
    Dim Count As Long
    Count = UBound(A)
    If Count <> UBound(B) Then Exit Function
    If Count = 2 Then
        If A(1, 1) <> 0# Then
            tmp = A(2, 2) - A(2, 1) / A(1, 1) * A(1, 2)
            If tmp <> 0 Then
                ReDim X(1 To 2)
                X(2) = (B(2) - A(2, 1) / A(1, 1) * B(1)) / tmp
                X(1) = (B(1) - A(1, 2) * X(2)) / A(1, 1)
                LineSystemGauss = True
            End If
        ElseIf A(1, 2) <> 0# Then
            If A(2, 1) <> 0# Then
                ReDim X(1 To 2)
                X(2) = B(1) / A(1, 2)
                X(1) = (B(2) - A(2, 2) * X(2)) / A(2, 1)
                LineSystemGauss = True
            End If
        End If
        Exit Function
    End If

    '  
    '   
    Dim m_B() As Double: m_B = B
    '  
    Dim M() As Double: M = A
    
    '    
    Dim i As Long, j As Long, k As Long
    
    Dim q As Double     '
    Dim rpl() As Long   '   
    Dim cRpl As Long    ' 
    
    For k = 1 To Count
        If M(k, k) = 0# Then
            '     
            i = k + 1
            j = k
            '  ,    
            Do While M(i, j) = 0#
                i = i + 1
                If i > Count Then
                    j = j + 1
                    If j > Count Then
                        '  
                        Exit Function
                    Else
                        i = k
                    End If
                End If
            Loop
            '  / 
            If i = k Then
                ' 
                M = SwapCols(M, k, j)
                '   
                cRpl = cRpl + 1
                ReDim Preserve rpl(1 To 2, 1 To cRpl)
                rpl(1, cRpl) = j
                rpl(2, cRpl) = k
            ElseIf j = k Then
                ' 
                M = SwapRows(M, i, k)
                '  
                tmp = m_B(i)
                m_B(i) = m_B(k)
                m_B(k) = tmp
            Else
                '    
                M = SwapCols(M, k, j)
                M = SwapRows(M, k, i)
                '  
                tmp = m_B(i)
                m_B(i) = m_B(k)
                m_B(k) = tmp
                '   
                cRpl = cRpl + 1
                ReDim Preserve rpl(1 To 2, 1 To cRpl)
                rpl(1, cRpl) = j
                rpl(2, cRpl) = k
            End If
        End If
        '      
        For i = k + 1 To Count
            q = -M(i, k) / M(k, k)
            M(i, k) = 0#
            m_B(i) = m_B(i) + q * m_B(k)
            For j = k + 1 To Count
                M(i, j) = M(i, j) + q * M(k, j)
            Next j
        Next i
    Next k
        
    ' 
    ReDim X(1 To Count)
    For i = Count To 1 Step -1
        tmp = 0#
        For j = i + 1 To Count
            tmp = tmp + M(i, j) * X(j)
        Next j
        X(i) = (m_B(i) - tmp) / M(i, i)
    Next i
    
    '   
    '   X
    If cRpl > 0 Then
        For i = cRpl To 1 Step -1
            tmp = X(rpl(1, i))
            X(rpl(1, i)) = X(rpl(2, i))
            X(rpl(2, i)) = tmp
        Next i
    End If
    LineSystemGauss = True
ErrLineSystemGauss:
End Function
'    AX=B  -
':  A -  ,    ( ,   !!!)
'       B - ,     ( ,   !!!)
'       X - ,     ( ,   !!!)
': True,   , False,   
Public Function LineSystemGaussJordan(A() As Double, B() As Double, _
                        X() As Double) As Boolean

    On Error GoTo ErrLineSystemGaussJordan
    '   
    If UBound(A, 1) <> UBound(A, 2) Then Exit Function


    Dim tmp As Double   ' 

    ' 
    Dim Count As Long
    Count = UBound(A)
    If Count <> UBound(B) Then Exit Function
    If Count = 2 Then
        If A(1, 1) <> 0# Then
            tmp = A(2, 2) - A(2, 1) / A(1, 1) * A(1, 2)
            If tmp <> 0 Then
                ReDim X(1 To 2)
                X(2) = (B(2) - A(2, 1) / A(1, 1) * B(1)) / tmp
                X(1) = (B(1) - A(1, 2) * X(2)) / A(1, 1)
                LineSystemGaussJordan = True
            End If
        ElseIf A(1, 2) <> 0# Then
            If A(2, 1) <> 0# Then
                ReDim X(1 To 2)
                X(2) = B(1) / A(1, 2)
                X(1) = (B(2) - A(2, 2) * X(2)) / A(2, 1)
                LineSystemGaussJordan = True
            End If
        End If
        Exit Function
    End If

    '  
    '   
    Dim m_B() As Double: m_B = B
    '  
    Dim M() As Double: M = A
    
    '    
    Dim i As Long, j As Long, k As Long
    
    Dim q As Double     '
    Dim rpl() As Long   '   
    Dim cRpl As Long    ' 
    
    For k = 1 To Count
        If M(k, k) = 0# Then
            '     
            i = k + 1
            j = k
            '  ,    
            Do While M(i, j) = 0#
                i = i + 1
                If i > Count Then
                    j = j + 1
                    If j > Count Then
                        '  
                        Exit Function
                    Else
                        i = k
                    End If
                End If
            Loop
            '  / 
            If i = k Then
                ' 
                M = SwapCols(M, k, j)
                '   
                cRpl = cRpl + 1
                ReDim Preserve rpl(1 To 2, 1 To cRpl)
                rpl(1, cRpl) = j
                rpl(2, cRpl) = k
            ElseIf j = k Then
                ' 
                M = SwapRows(M, i, k)
                '  
                tmp = m_B(i)
                m_B(i) = m_B(k)
                m_B(k) = tmp
            Else
                '    
                M = SwapCols(M, k, j)
                M = SwapRows(M, k, i)
                '  
                tmp = m_B(i)
                m_B(i) = m_B(k)
                m_B(k) = tmp
                '   
                cRpl = cRpl + 1
                ReDim Preserve rpl(1 To 2, 1 To cRpl)
                rpl(1, cRpl) = j
                rpl(2, cRpl) = k
            End If
        End If
        '      
        For i = 1 To Count
            If i <> k Then
                q = -M(i, k) / M(k, k)
                M(i, k) = 0#
                m_B(i) = m_B(i) + q * m_B(k)
                For j = k + 1 To Count
                    M(i, j) = M(i, j) + q * M(k, j)
                Next j
            End If
        Next i
    Next k
        
    ' 
    ReDim X(1 To Count)
    For i = Count To 1 Step -1
        X(i) = m_B(i) / M(i, i)
    Next i
    
    '   
    '   X
    If cRpl > 0 Then
        For i = cRpl To 1 Step -1
            tmp = X(rpl(1, i))
            X(rpl(1, i)) = X(rpl(2, i))
            X(rpl(2, i)) = tmp
        Next i
    End If
    LineSystemGaussJordan = True
ErrLineSystemGaussJordan:
End Function
'    AX=B   
':  A -  ,    ( ,   !!!)
'       B - ,     ( ,   !!!)
'       X - ,     ( ,   !!!)
': True,   , False,   
Public Function LineSystemGaussEx(A() As Double, B() As Double, _
                        X() As Double) As Boolean

    On Error GoTo ErrLineSystemGaussEx
    '   
    If UBound(A, 1) <> UBound(A, 2) Then Exit Function


    Dim tmp As Double   ' 

    ' 
    Dim Count As Long
    Count = UBound(A)
    If Count <> UBound(B) Then Exit Function
    If Count = 2 Then
        If A(1, 1) <> 0# Then
            tmp = A(2, 2) - A(2, 1) / A(1, 1) * A(1, 2)
            If tmp <> 0 Then
                ReDim X(1 To 2)
                X(2) = (B(2) - A(2, 1) / A(1, 1) * B(1)) / tmp
                X(1) = (B(1) - A(1, 2) * X(2)) / A(1, 1)
                LineSystemGaussEx = True
            End If
        ElseIf A(1, 2) <> 0# Then
            If A(2, 1) <> 0# Then
                ReDim X(1 To 2)
                X(2) = B(1) / A(1, 2)
                X(1) = (B(2) - A(2, 2) * X(2)) / A(2, 1)
                LineSystemGaussEx = True
            End If
        End If
        Exit Function
    End If

    '  
    '   
    Dim m_B() As Double: m_B = B
    '  
    Dim M() As Double: M = A
    
    '    
    Dim i As Long, j As Long, k As Long
    
    Dim q As Double     '
    Dim rpl() As Long   '   
    Dim cRpl As Long    ' 
    
    For k = 1 To Count
        Dim tMax As Double:     tMax = M(k, k)
        Dim iMax As Integer:    iMax = k
        Dim jMax As Integer:    jMax = k
        '    
        For i = k To Count
            For j = k To Count
                If Abs(M(i, j)) > Abs(tMax) Then
                    iMax = i
                    jMax = j
                    tMax = M(i, j)
                End If
            Next
        Next
        '  / 
        If iMax = k Then
            ' 
            M = SwapCols(M, k, jMax)
            '  
            cRpl = cRpl + 1
            ReDim Preserve rpl(1 To 2, 1 To cRpl)
            rpl(1, cRpl) = jMax
            rpl(2, cRpl) = k
        ElseIf jMax = k Then
            ' 
            M = SwapRows(M, k, iMax)
            '  
            tmp = m_B(iMax)
            m_B(iMax) = m_B(k)
            m_B(k) = tmp
        Else
            ' 
            M = SwapCols(M, k, jMax)
            '  
            cRpl = cRpl + 1
            ReDim Preserve rpl(1 To 2, 1 To cRpl)
            rpl(1, cRpl) = jMax
            rpl(2, cRpl) = k
            ' 
            M = SwapRows(M, k, iMax)
            '  
            tmp = m_B(iMax)
            m_B(iMax) = m_B(k)
            m_B(k) = tmp
        End If
        '       
        For i = k + 1 To Count
            q = -M(i, k) / M(k, k)
            M(i, k) = 0#
            m_B(i) = m_B(i) + q * m_B(k)
            For j = k + 1 To Count
                M(i, j) = M(i, j) + q * M(k, j)
            Next
        Next
    Next k
        
    ' 
    ReDim X(1 To Count)
    For i = Count To 1 Step -1
        tmp = 0#
        For j = i + 1 To Count
            tmp = tmp + M(i, j) * X(j)
        Next j
        X(i) = (m_B(i) - tmp) / M(i, i)
    Next i
    
    '   
    '   X
    If cRpl > 0 Then
        For i = cRpl To 1 Step -1
            tmp = X(rpl(1, i))
            X(rpl(1, i)) = X(rpl(2, i))
            X(rpl(2, i)) = tmp
        Next i
    End If
    LineSystemGaussEx = True
ErrLineSystemGaussEx:
End Function
'    AX=B   -
':  A -  ,    ( ,   !!!)
'       B - ,     ( ,   !!!)
'       X - ,     ( ,   !!!)
': True,   , False,   
Public Function LineSystemGaussJordanEx(A() As Double, B() As Double, _
                        X() As Double) As Boolean

    On Error GoTo ErrLineSystemGaussJordanEx
    '   
    If UBound(A, 1) <> UBound(A, 2) Then Exit Function


Dim tmp As Double   ' 

    ' 
    Dim Count As Long
    Count = UBound(A)
    If Count <> UBound(B) Then Exit Function
    If Count = 2 Then
        If A(1, 1) <> 0# Then
            tmp = A(2, 2) - A(2, 1) / A(1, 1) * A(1, 2)
            If tmp <> 0 Then
                ReDim X(1 To 2)
                X(2) = (B(2) - A(2, 1) / A(1, 1) * B(1)) / tmp
                X(1) = (B(1) - A(1, 2) * X(2)) / A(1, 1)
                LineSystemGaussJordanEx = True
            End If
        ElseIf A(1, 2) <> 0# Then
            If A(2, 1) <> 0# Then
                ReDim X(1 To 2)
                X(2) = B(1) / A(1, 2)
                X(1) = (B(2) - A(2, 2) * X(2)) / A(2, 1)
                LineSystemGaussJordanEx = True
            End If
        End If
        Exit Function
    End If

    '  
    '   
    Dim m_B() As Double: m_B = B
    '  
    Dim M() As Double: M = A
    
    '    
    Dim i As Long, j As Long, k As Long
    
    Dim q As Double     '
    Dim rpl() As Long   '   
    Dim cRpl As Long    ' 
    
    For k = 1 To Count
        Dim tMax As Double:     tMax = M(k, k)
        Dim iMax As Integer:    iMax = k
        Dim jMax As Integer:    jMax = k
        '    
        For i = k To Count
            For j = k To Count
                If Abs(M(i, j)) > Abs(tMax) Then
                    iMax = i
                    jMax = j
                    tMax = M(i, j)
                End If
            Next
        Next
        '  / 
        If iMax = k Then
            ' 
            M = SwapCols(M, k, jMax)
            '   
            cRpl = cRpl + 1
            ReDim Preserve rpl(1 To 2, 1 To cRpl)
            rpl(1, cRpl) = jMax
            rpl(2, cRpl) = k
        ElseIf jMax = k Then
            ' 
            M = SwapRows(M, iMax, k)
            '  
            tmp = m_B(iMax)
            m_B(iMax) = m_B(k)
            m_B(k) = tmp
        Else
            '    
            M = SwapCols(M, k, jMax)
            M = SwapRows(M, k, iMax)
            '  
            tmp = m_B(iMax)
            m_B(iMax) = m_B(k)
            m_B(k) = tmp
            '   
            cRpl = cRpl + 1
            ReDim Preserve rpl(1 To 2, 1 To cRpl)
            rpl(1, cRpl) = jMax
            rpl(2, cRpl) = k
        End If
        '      
        For i = 1 To Count
            If i <> k Then
                q = -M(i, k) / M(k, k)
                M(i, k) = 0#
                m_B(i) = m_B(i) + q * m_B(k)
                For j = k + 1 To Count
                    M(i, j) = M(i, j) + q * M(k, j)
                Next j
            End If
        Next i
    Next k
        
    ' 
    ReDim X(1 To Count)
    For i = Count To 1 Step -1
        X(i) = m_B(i) / M(i, i)
    Next i
    
    '   
    '   X
    If cRpl > 0 Then
        For i = cRpl To 1 Step -1
            tmp = X(rpl(1, i))
            X(rpl(1, i)) = X(rpl(2, i))
            X(rpl(2, i)) = tmp
        Next i
    End If
    LineSystemGaussJordanEx = True
ErrLineSystemGaussJordanEx:
End Function
'    AX=B  
':  A -  ,    ( ,   !!!)
'       B - ,     ( ,   !!!)
'       X - ,     ( ,   !!!)
': True,   , False,   
Public Function LineSystemKramer(A() As Double, B() As Double, _
                            X() As Double) As Boolean
Dim tmp() As Double '    
Dim D() As Double   ' 

    On Error GoTo ErrLineSystemK
    ' 
    Dim Count As Long
    Count = UBound(A)
    If Count <> 0 Then
        ReDim X(1 To Count)
        ReDim D(0 To Count)
        ReDim tmp(Count, Count)
        '  
        D(0) = Determinant(A)
        If D(0) <> 0# Then
            Dim i As Long, j As Long, l As Long
            For l = 1 To Count
                ' l-    
                For i = 1 To Count
                    For j = 1 To Count
                        If l <> i Then
                            tmp(j, i) = A(j, i)
                        Else
                            tmp(j, i) = B(j)
                        End If
                    Next j
                Next i
                '   l-
                D(l) = Determinant(tmp)
                ' Xl
                X(l) = D(l) / D(0)
            Next l
        End If
    End If
    LineSystemKramer = True
ErrLineSystemK:
End Function
'    AX=B       
':  A -  ,    ( ,   !!!)
'       B -  ,     ( ,   !!!)
'       X -  ,     ( ,   !!!)
': True,   , False,   
Public Function LineSystemGaussN(A() As Double, B() As Double, _
                        X() As Double) As Boolean

    On Error GoTo ErrLineSystemGaussN
    '   
    If UBound(A, 1) <> UBound(A, 2) Then Exit Function


    Dim tmp As Double   ' 

    ' 
    Dim Count As Long
    Count = UBound(A)
    '  
    Dim N As Long
    N = UBound(B, 2)
    If Count <> UBound(B, 1) Then Exit Function
    Dim i As Long
    If Count = 2 Then
        If A(1, 1) <> 0# Then
            tmp = A(2, 2) - A(2, 1) / A(1, 1) * A(1, 2)
            If tmp <> 0 Then
                ReDim X(1 To 2, 1 To N)
                For i = 1 To N
                    X(2, i) = (B(2, i) - A(2, 1) / A(1, 1) * B(1, i)) / tmp
                    X(1, i) = (B(1, i) - A(1, 2) * X(2, i)) / A(1, 1)
                Next i
                LineSystemGaussN = True
            End If
        ElseIf A(1, 2) <> 0# Then
            If A(2, 1) <> 0# Then
                ReDim X(1 To 2, 1 To N)
                For i = 1 To N
                    X(2, i) = B(1, i) / A(1, 2)
                    X(1, i) = (B(2, i) - A(2, 2) * X(2, i)) / A(2, 1)
                Next i
                LineSystemGaussN = True
            End If
        End If
        Exit Function
    End If

    '  
    '   
    Dim m_B() As Double: m_B = B
    '  
    Dim M() As Double: M = A
    
    '    
    Dim j As Long, k As Long, l As Long
    
    Dim q As Double     '
    Dim rpl() As Long   '   
    Dim cRpl As Long    ' 
    
    For k = 1 To Count
        If M(k, k) = 0# Then
            '     
            i = k + 1
            j = k
            '  ,    
            Do While M(i, j) = 0#
                i = i + 1
                If i > Count Then
                    j = j + 1
                    If j > Count Then
                        '  
                        Exit Function
                    Else
                        i = k
                    End If
                End If
            Loop
            '  / 
            If i = k Then
                ' 
                M = SwapCols(M, k, j)
                '   
                cRpl = cRpl + 1
                ReDim Preserve rpl(1 To 2, 1 To cRpl)
                rpl(1, cRpl) = j
                rpl(2, cRpl) = k
            ElseIf j = k Then
                ' 
                M = SwapRows(M, i, k)
                '  
                For l = 1 To N
                    tmp = m_B(i, l)
                    m_B(i, l) = m_B(k, l)
                    m_B(k, l) = tmp
                Next l
            Else
                '    
                M = SwapCols(M, k, j)
                M = SwapRows(M, k, i)
                '  
                For l = 1 To N
                    tmp = m_B(i, l)
                    m_B(i, l) = m_B(k, l)
                    m_B(k, l) = tmp
                Next l
                '   
                cRpl = cRpl + 1
                ReDim Preserve rpl(1 To 2, 1 To cRpl)
                rpl(1, cRpl) = j
                rpl(2, cRpl) = k
            End If
        End If
        '      
        For i = k + 1 To Count
            q = -M(i, k) / M(k, k)
            M(i, k) = 0#
            For l = 1 To N
                m_B(i, l) = m_B(i, l) + q * m_B(k, l)
            Next l
            For j = k + 1 To Count
                M(i, j) = M(i, j) + q * M(k, j)
            Next j
        Next i
    Next k
        
    ' 
    ReDim X(1 To Count, 1 To N)
    For i = Count To 1 Step -1
        For l = 1 To N
            tmp = 0#
            For j = i + 1 To Count
                tmp = tmp + M(i, j) * X(j, l)
            Next j
            X(i, l) = (m_B(i, l) - tmp) / M(i, i)
        Next l
    Next i
    
    '   
    '   X
    If cRpl > 0 Then
        For i = cRpl To 1 Step -1
            For l = 1 To N
                tmp = X(rpl(1, i), l)
                X(rpl(1, i), l) = X(rpl(2, i), l)
                X(rpl(2, i), l) = tmp
            Next l
        Next i
    End If
    LineSystemGaussN = True
ErrLineSystemGaussN:
End Function
'    AX=B  -     
':  A -  ,    ( ,   !!!)
'       B -  ,     ( ,   !!!)
'       X -  ,     ( ,   !!!)
': True,   , False,   
Public Function LineSystemGaussJordanN(A() As Double, B() As Double, _
                        X() As Double) As Boolean

    On Error GoTo ErrLineSystemGaussJordanN
    '   
    If UBound(A, 1) <> UBound(A, 2) Then Exit Function


    Dim tmp As Double   ' 

    ' 
    Dim Count As Long
    Count = UBound(A)
    '  
    Dim N As Long
    N = UBound(B, 2)
    If Count <> UBound(B, 1) Then Exit Function
    Dim i As Long
    If Count = 2 Then
        If A(1, 1) <> 0# Then
            tmp = A(2, 2) - A(2, 1) / A(1, 1) * A(1, 2)
            If tmp <> 0 Then
                ReDim X(1 To 2, 1 To N)
                For i = 1 To N
                    X(2, i) = (B(2, i) - A(2, 1) / A(1, 1) * B(1, i)) / tmp
                    X(1, i) = (B(1, i) - A(1, 2) * X(2, i)) / A(1, 1)
                Next i
                LineSystemGaussJordanN = True
            End If
        ElseIf A(1, 2) <> 0# Then
            If A(2, 1) <> 0# Then
                ReDim X(1 To 2, 1 To N)
                For i = 1 To N
                    X(2, i) = B(1, i) / A(1, 2)
                    X(1, i) = (B(2, i) - A(2, 2) * X(2, i)) / A(2, 1)
                Next i
                LineSystemGaussJordanN = True
            End If
        End If
        Exit Function
    End If

    '  
    '   
    Dim m_B() As Double: m_B = B
    '  
    Dim M() As Double: M = A
    
    '    
    Dim j As Long, k As Long, l As Long
    
    Dim q As Double     '
    Dim rpl() As Long   '   
    Dim cRpl As Long    ' 
    
    For k = 1 To Count
        If M(k, k) = 0# Then
            '     
            i = k + 1
            j = k
            '  ,    
            Do While M(i, j) = 0#
                i = i + 1
                If i > Count Then
                    j = j + 1
                    If j > Count Then
                        '  
                        Exit Function
                    Else
                        i = k
                    End If
                End If
            Loop
            '  / 
            If i = k Then
                ' 
                M = SwapCols(M, k, j)
                '   
                cRpl = cRpl + 1
                ReDim Preserve rpl(1 To 2, 1 To cRpl)
                rpl(1, cRpl) = j
                rpl(2, cRpl) = k
            ElseIf j = k Then
                ' 
                M = SwapRows(M, i, k)
                '  
                tmp = m_B(i)
                m_B(i) = m_B(k)
                m_B(k) = tmp
            Else
                '    
                M = SwapCols(M, k, j)
                M = SwapRows(M, k, i)
                '  
                For l = 1 To N
                    tmp = m_B(i, l)
                    m_B(i, l) = m_B(k, l)
                    m_B(k, l) = tmp
                Next l
                '   
                cRpl = cRpl + 1
                ReDim Preserve rpl(1 To 2, 1 To cRpl)
                rpl(1, cRpl) = j
                rpl(2, cRpl) = k
            End If
        End If
        '      
        For i = 1 To Count
            If i <> k Then
                q = -M(i, k) / M(k, k)
                M(i, k) = 0#
                For l = 1 To N
                    m_B(i, l) = m_B(i, l) + q * m_B(k, l)
                Next l
                For j = k + 1 To Count
                    M(i, j) = M(i, j) + q * M(k, j)
                Next j
            End If
        Next i
    Next k
        
    ' 
    ReDim X(1 To Count, 1 To N)
    For i = Count To 1 Step -1
        For l = 1 To N
            X(i, l) = m_B(i, l) / M(i, i)
        Next l
    Next i
    
    '   
    '   X
    If cRpl > 0 Then
        For i = cRpl To 1 Step -1
            For l = 1 To N
                tmp = X(rpl(1, i), l)
                X(rpl(1, i), l) = X(rpl(2, i), l)
                X(rpl(2, i), l) = tmp
            Next l
        Next i
    End If
    LineSystemGaussJordanN = True
ErrLineSystemGaussJordanN:
End Function
'    AX=B        
':  A -  ,    ( ,   !!!)
'       B -  ,     ( ,   !!!)
'       X -  ,     ( ,   !!!)
': True,   , False,   
Public Function LineSystemGaussExN(A() As Double, B() As Double, _
                        X() As Double) As Boolean

    On Error GoTo ErrLineSystemGaussExN
    '   
    If UBound(A, 1) <> UBound(A, 2) Then Exit Function


    Dim tmp As Double   ' 

    ' 
    Dim Count As Long
    Count = UBound(A)
    '  
    Dim N As Long
    N = UBound(B, 2)
    If Count <> UBound(B, 1) Then Exit Function
    Dim i As Long
    If Count = 2 Then
        If A(1, 1) <> 0# Then
            tmp = A(2, 2) - A(2, 1) / A(1, 1) * A(1, 2)
            If tmp <> 0 Then
                ReDim X(1 To 2, 1 To N)
                For i = 1 To N
                    X(2, i) = (B(2, i) - A(2, 1) / A(1, 1) * B(1, i)) / tmp
                    X(1, i) = (B(1, i) - A(1, 2) * X(2, i)) / A(1, 1)
                Next i
                LineSystemGaussExN = True
            End If
        ElseIf A(1, 2) <> 0# Then
            If A(2, 1) <> 0# Then
                ReDim X(1 To 2, 1 To N)
                For i = 1 To N
                    X(2, i) = B(1, i) / A(1, 2)
                    X(1, i) = (B(2, i) - A(2, 2) * X(2, i)) / A(2, 1)
                Next i
                LineSystemGaussExN = True
            End If
        End If
        Exit Function
    End If

    '  
    '   
    Dim m_B() As Double: m_B = B
    '  
    Dim M() As Double: M = A
    
    '    
    Dim j As Long, k As Long, l As Long
    
    Dim q As Double     '
    Dim rpl() As Long   '   
    Dim cRpl As Long    ' 
    
    For k = 1 To Count
        Dim tMax As Double:     tMax = M(k, k)
        Dim iMax As Integer:    iMax = k
        Dim jMax As Integer:    jMax = k
        '    
        For i = k To Count
            For j = k To Count
                If Abs(M(i, j)) > Abs(tMax) Then
                    iMax = i
                    jMax = j
                    tMax = M(i, j)
                End If
            Next
        Next
        '  / 
        If iMax = k Then
            ' 
            M = SwapCols(M, k, jMax)
            '  
            cRpl = cRpl + 1
            ReDim Preserve rpl(1 To 2, 1 To cRpl)
            rpl(1, cRpl) = jMax
            rpl(2, cRpl) = k
        ElseIf jMax = k Then
            ' 
            M = SwapRows(M, k, iMax)
            '  
            For l = 1 To N
                tmp = m_B(iMax, l)
                m_B(iMax, l) = m_B(k, l)
                m_B(k, l) = tmp
            Next l
        Else
            ' 
            M = SwapCols(M, k, jMax)
            '  
            cRpl = cRpl + 1
            ReDim Preserve rpl(1 To 2, 1 To cRpl)
            rpl(1, cRpl) = jMax
            rpl(2, cRpl) = k
            ' 
            M = SwapRows(M, k, iMax)
            '  
            For l = 1 To N
                tmp = m_B(iMax, l)
                m_B(iMax, l) = m_B(k, l)
                m_B(k, l) = tmp
            Next l
        End If
        '       
        For i = k + 1 To Count
            q = -M(i, k) / M(k, k)
            M(i, k) = 0#
            For l = 1 To N
                m_B(i, l) = m_B(i, l) + q * m_B(k, l)
            Next l
            For j = k + 1 To Count
                M(i, j) = M(i, j) + q * M(k, j)
            Next
        Next
    Next k
        
    ' 
    ReDim X(1 To Count, 1 To N)
    For i = Count To 1 Step -1
        For l = 1 To N
            tmp = 0#
            For j = i + 1 To Count
                tmp = tmp + M(i, j) * X(j, l)
            Next j
            X(i, l) = (m_B(i, l) - tmp) / M(i, i)
        Next l
    Next i
    
    '   
    '   X
    If cRpl > 0 Then
        For i = cRpl To 1 Step -1
            For l = 1 To N
                tmp = X(rpl(1, i), l)
                X(rpl(1, i), l) = X(rpl(2, i), l)
                X(rpl(2, i), l) = tmp
            Next l
        Next i
    End If
    LineSystemGaussExN = True
ErrLineSystemGaussExN:
End Function
'    AX=B   -     
':  A -  ,    ( ,   !!!)
'       B -  ,     ( ,   !!!)
'       X -  ,     ( ,   !!!)
': True,   , False,   
Public Function LineSystemGaussJordanExN(A() As Double, B() As Double, _
                        X() As Double) As Boolean

    On Error GoTo ErrLineSystemGaussJordanExN
    '   
    If UBound(A, 1) <> UBound(A, 2) Then Exit Function


    Dim tmp As Double   ' 

    ' 
    Dim Count As Long
    Count = UBound(A)
    '  
    Dim N As Long
    N = UBound(B, 2)
    If Count <> UBound(B, 1) Then Exit Function
    Dim i As Long
    If Count = 2 Then
        If A(1, 1) <> 0# Then
            tmp = A(2, 2) - A(2, 1) / A(1, 1) * A(1, 2)
            If tmp <> 0 Then
                ReDim X(1 To 2, 1 To N)
                For i = 1 To N
                    X(2, i) = (B(2, i) - A(2, 1) / A(1, 1) * B(1, i)) / tmp
                    X(1, i) = (B(1, i) - A(1, 2) * X(2, i)) / A(1, 1)
                Next i
                LineSystemGaussJordanExN = True
            End If
        ElseIf A(1, 2) <> 0# Then
            If A(2, 1) <> 0# Then
                ReDim X(1 To 2, 1 To N)
                For i = 1 To N
                    X(2, i) = B(1, i) / A(1, 2)
                    X(1, i) = (B(2, i) - A(2, 2) * X(2, i)) / A(2, 1)
                Next i
                LineSystemGaussJordanExN = True
            End If
        End If
        Exit Function
    End If

    '  
    '   
    Dim m_B() As Double: m_B = B
    '  
    Dim M() As Double: M = A
    
    '    
    Dim j As Long, k As Long, l As Long
    
    Dim q As Double     '
    Dim rpl() As Long   '   
    Dim cRpl As Long    ' 
    
    For k = 1 To Count
        Dim tMax As Double: tMax = M(k, k)
        Dim iMax As Integer: iMax = k
        Dim jMax As Integer: jMax = k
        '    
        For i = k To Count
            For j = k To Count
                If Abs(M(i, j)) > Abs(tMax) Then
                    iMax = i
                    jMax = j
                    tMax = M(i, j)
                End If
            Next
        Next
        '  / 
        If iMax = k Then
            ' 
            M = SwapCols(M, k, jMax)
            '   
            cRpl = cRpl + 1
            ReDim Preserve rpl(1 To 2, 1 To cRpl)
            rpl(1, cRpl) = jMax
            rpl(2, cRpl) = k
        ElseIf jMax = k Then
            ' 
            M = SwapRows(M, iMax, k)
            '  
            For l = 1 To N
                tmp = m_B(iMax, l)
                m_B(iMax, l) = m_B(k, l)
                m_B(k, l) = tmp
            Next l
        Else
            '    
            M = SwapCols(M, k, jMax)
            M = SwapRows(M, k, iMax)
            '  
            For l = 1 To N
                tmp = m_B(iMax, l)
                m_B(iMax, l) = m_B(k, l)
                m_B(k, l) = tmp
            Next l
            '   
            cRpl = cRpl + 1
            ReDim Preserve rpl(1 To 2, 1 To cRpl)
            rpl(1, cRpl) = jMax
            rpl(2, cRpl) = k
        End If
        '      
        For i = 1 To Count
            If i <> k Then
                q = -M(i, k) / M(k, k)
                M(i, k) = 0#
                For l = 1 To N
                    m_B(i, l) = m_B(i, l) + q * m_B(k, l)
                Next l
                'm_B(i) = m_B(i) + q * m_B(k)
                For j = k + 1 To Count
                    M(i, j) = M(i, j) + q * M(k, j)
                Next j
            End If
        Next i
    Next k
        
    ' 
    ReDim X(1 To Count, 1 To N)
    For i = Count To 1 Step -1
        For l = 1 To N
            X(i, l) = m_B(i, l) / M(i, i)
        Next l
    Next i
    
    '   
    '   X
    If cRpl > 0 Then
        For i = cRpl To 1 Step -1
            For l = 1 To N
                tmp = X(rpl(1, i), l)
                X(rpl(1, i), l) = X(rpl(2, i), l)
                X(rpl(2, i), l) = tmp
            Next l
        Next i
    End If
    LineSystemGaussJordanExN = True
ErrLineSystemGaussJordanExN:
End Function
' ,     
':  n1, n2 -  
':   
Private Function Min(n1 As Double, n2 As Double) As Double
    If n1 < n2 Then
        Min = n1
    Else
        Min = n2
    End If
End Function
